unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, StdCtrls, Xtree2_unit;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    initBtn: TSpeedButton;
    afterBtn: TSpeedButton;
    beforeBtn: TSpeedButton;
    firstchildBtn: TSpeedButton;
    lastchildBtn: TSpeedButton;
    Label2: TLabel;
    deleteBtn: TSpeedButton;
    undoBtn: TSpeedButton;
    baselabel: TLabel;
    steplabel: TLabel;
    CheckBox1: TCheckBox;
    scanBtn: TSpeedButton;
    nextBtn: TSpeedButton;
    destroyBtn: TSpeedButton;
    udoBaseLabel: TLabel;
    undoStepLabel: TLabel;
    Label3: TLabel;
    maxsteplabel: TLabel;
    markBtn: TSpeedButton;
    compressBtn: TSpeedButton;
    expandBtn: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    freeElementslabel: TLabel;
    replaceBtn: TSpeedButton;
    cleanupBtn: TSpeedButton;
    saveBtn: TSpeedButton;
    reloadBtn: TSpeedButton;
    ellinkbox: TPaintBox;
    Label4: TLabel;
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure afterBtnClick(Sender: TObject);
    procedure deleteBtnClick(Sender: TObject);
    procedure nextBtnClick(Sender: TObject);
    procedure destroyBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure markBtnClick(Sender: TObject);
    procedure CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure initBtnClick(Sender: TObject);
    procedure undoBtnClick(Sender: TObject);
    procedure scanBtnClick(Sender: TObject);
    procedure compressBtnClick(Sender: TObject);
    procedure expandBtnClick(Sender: TObject);
    procedure replaceBtnClick(Sender: TObject);
    procedure cleanupBtnClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure reloadBtnClick(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ellinkboxPaint(Sender: TObject);
  private
    { Private declarations }
  public
    {}
  end;
  TElementStatus = (esFree,esActive);
  Telement = record
              status : TElementStatus;
              mark   : byte; //property 0,1,2,3
              posX,posY : byte;
              parent : word;
              child  : word;
              next   : word;
              previous : word;
              Cstep : byte;     //create step
              Dstep : byte;     //delete (replaced) step
             end;

const maxElement = 48;

procedure undomessage(um : TUndoMessage; nel,del : word);

var
  Form1: TForm1;
  element : array[1..maxelement] of Telement;

implementation

{$R *.dfm}

type TsaveCode =(svEL,svPar1,svPar2,svEnd);//backUp codes

{  par1 = '('  start of child elements
   par2 = ')'  end of child elements   }
{   
  tree save format
  -------------------------------------------------
  |Edsteps-Edbase|                                //1 word
  |svEL   -mark  |element#|child|next|Cstep-Dstep|//5 words
  |svEnd --------|                                //1 word

  tree compress format
  -------------------------------------------------
  |svEL  |  mark  |                        //2 bytes
  |svPar1|                                 //1 byte
  |svPar2|                                 //1 bytes
  |svEnd |
}

const border = 10;
      Hspacing = 80;
      Vspacing = 40;
      elwidth = 60;
      elheight = 30;
      Hcenter = elwidth shr 1;
      Vcenter = elheight shr 1;

var map : Tbitmap;
    ellinkmap : Tbitmap;
    actEL  : word;//active element
    hooverEL : word;
    topY : byte;  //needed for tree drawing
    slink : Tlink;
    scanStart : word;
    freeElements : word;
    CPtree : array[1..300] of byte;//compressed tree no undo info
    SVtree : array[1..300] of word;//saved tree with undo info
    saveFlag : boolean;    //true if tree saved
    compressflag : boolean;//true if tree compressed

procedure showEdCounts;
//display undobase, undostep
begin
 with form1 do
  begin
   Baselabel.caption := inttostr(GetEdBase);
   StepLabel.Caption := inttostr(GetEdStep);
  end;
end;

procedure NewActEL;
//select new active element
begin
 if actEL = 0 then actEL := 1
  else if getNext(actEL,actEL) = false then
        if getPrevious(actEL,actEL) = false then
         if getParent(actEL,actEL) = false then actEL := 1;
end;

procedure getIdleXY(var x,y : smallInt; elnr : byte);
//supply coords of idle or deleted element
begin
 x := ((elnr-1) and 1)*Hspacing + 840;
 y := ((elNr-1) shr 1)*Vspacing + border;
end;

procedure getActiveXY(var x,y : smallInt; px,py : byte);
//px,py are coordinates of 50 * 40 pixel rectangles
begin
 x := (px-1)*Hspacing + border;
 y := (py-1)*Vspacing + border;
end;

procedure GetElementXY(var x,y : smallInt; elmnt : word);
//supply left-top pixel coords of element elmnt
begin
 with element[elmnt] do
  if (status=esFree) then getIdleXY(x,y,elmnt)
   else getActiveXY(x,y,posX,posY);
end;

function XYtoElement(var el : word; x,y : smallInt) : boolean;
//called by mousedown on paintbox1, return element nr
var i : word;
    x1,y1,x2,y2 : smallInt;
begin
 i := 0;
 repeat
  inc(i);
  with element[i] do
    begin
     getActiveXY(x1,y1,posX,posY);
     x2 := x1 + elWidth;
     y2 := y1 + elHeight;
     result := (x > x1) and (x < x2) and (y > y1) and (y < y2);
     if result then el := i;
    end;
 until result or (i = maxElement);
end;

procedure initElements;
var i : word;
begin
 for i := 1 to maxelement do
  with element[i] do
   begin
    status := esFree;
    mark := 0;
    posX := 0;
    posY := 0;
   end;
 element[1].status := esActive;
 ActEL := 1;
 freeElements := maxElement-1;
 form1.freeElementsLabel.caption := inttostr(freeElements);
end;

function GetFreeElement : word;
var i : word;
begin
 result := 0;
 i := 1;
 while (result=0) and (i<= maxElement) do
  if element[i].status = esFree then result := i else inc(i);
 if result > 0 then
  begin
   dec(freeElements);
   form1.freeElementsLabel.caption := inttostr(freeElements);
  end;
end;

procedure paintElement(el : word);
//paint element el on map
var x1,y1,x2,y2 : smallint;
    i : byte;
    s : string;
    ch : char;
    Dflag : boolean;
begin
 with map.Canvas do
  with element[el] do
   begin
    Dflag := testELdeleted(el);
    if (status = esFree) or Dflag then pen.color := $c0c0c0
     else if el = actEL then pen.color := $0000ff
           else pen.color := $000000;
    if Dflag then brush.Color := $e0e0e0
     else
     case mark of
      0 : brush.color := $ffffff;
      1 : brush.Color := $80ffff;
      2 : brush.Color := $ff80ff;
      3 : brush.color := $ffff80;
     end;
    brush.style := bsSolid;
    getElementXY(x1,y1,el);
    x2 := x1 + elWidth;
    y2 := y1 + elHeight;
    fillrect(rect(x1,y1,x2,y2));
    pen.width := 1;
    dec(x2);
    dec(y2);
    for i := 0 to 1 do
     begin
      moveto(x1+i,y1+i);
      lineto(x1+i,y2-i);
      lineto(x2-i,y2-i);
      lineto(x2-i,y1+i);
      lineto(x1+i,y1+i);
     end;
    font.height := 18;
    font.color := $000000;
    brush.style := bsClear;
    s := inttostr(el);
    textout(x1+2,y1+5,s); //element numbers
    font.height := 14;
    if CStep > 0 then textout(x1+35,y1,'C'+inttostr(Cstep and $7f));
    if Dstep > 0 then
     begin
      if (Dstep and $80) = $80 then ch := 'R' else ch := 'D';
      textout(x1+35,y1+15,ch+inttostr(Dstep and $7f));
     end;
   end;
end;

procedure paintline(EL1,EL2 : word);
//paint connection between elements EL1,EL2
var x1,y1,x2,y2 : smallInt;
begin
 with map.Canvas do
  begin
   pen.Color := $0;
   pen.Width := 2;
   getActiveXY(x1,y1,element[EL1].posX,element[EL1].posY);
   getActiveXY(x2,y2,element[EL2].posX,element[EL2].posY);
   if y1 = y2 then
    begin
     moveto(x1+elWidth,y1+Vcenter);
     lineto(x2,y2+Vcenter);
    end;
   if x1 = x2 then
    begin
     moveto(x1+Hcenter,y1+elHeight);
     lineto(x2+Hcenter,y2);
    end;
  end;
end;

procedure repaintElement(elmnt : word);
//repaint element elmnt on map and copy rectangle to paintbox1
var r : Trect;
    x,y : smallInt;
begin
 paintElement(elmnt);
 with element[elmnt] do getActiveXY(x,y,posX,posY);
 r := rect(x,y,x+elWidth,y+elHeight);
 form1.paintbox1.canvas.copyrect(r,map.canvas,r);
end;

procedure clearmap(mp : Tbitmap);
begin
 with mp do with Canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure paintmap;
var i : byte;
    pX,pY : byte;
    link : TLink;
    elmnt,oldElmnt : word;
    Pflag : boolean;
begin
 with map do with Canvas do
  begin
   font.Name := 'arial';
   font.Style := [];
   clearmap(map);
  end;
  for i := 1 to maxElement do  //search for free or deleted elements
   if (element[i].Status = esFree) {or (element[i].Dstep > 0)} then paintElement(i);
  pX := 1;
  pY := 1;
  topY := 1;
  elmnt := 1;
  oldElmnt := 0;
  Pflag := true;
  link := ltNext;
  repeat
   if Pflag then
    begin
     with element[elmnt] do
      begin
       posX := pX;
       posY := pY;
      end;
     paintElement(elmnt);
     if oldElmnt > 0 then paintline(oldElmnt,elmnt);
    end;
   oldElmnt := elmnt;
   link := fullscan(elmnt,link);
   case link of
    ltParent   : begin
                  dec(pX);
                  Pflag := false;
                 end;
    ltChild    : begin
                  inc(pX);
                  Pflag := true;
                 end;
    ltNext     : begin
                  inc(pY);
                  if pY <= topY then pY := topY+1;
                  Pflag := true;
                  inc(topY);
                 end;
    ltPrevious : begin
                  dec(pY);
                  Pflag := false;
                 end;
   end;//case
  until (link=ltNone) or ((elmnt=1) and (link=ltPrevious));
end;

procedure paintedges(bx : TPaintbox; col1,coll2 : dword);
//paint edges around paintbox bx
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with bx do
  begin
   x1 := left-2;
   x2 := left + width + 1;
   y1 := top - 2;
   y2 := top + height + 1;
  end;
 with form1.canvas do
  begin
   pen.Width := 1;
   for i := 0 to 1 do
    begin
     pen.Color := col1;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := coll2;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure paintlinks;
//use hooverEL
var el : word;
begin
 clearmap(ellinkmap);
 with ellinkmap.Canvas do
  begin
   pen.Width := 2;
   rectangle(30,30,90,60);
   brush.style := bsClear;
   if hooverEL > 0 then
    begin
     font.Name := 'arial';
     font.Height := 24;
     font.Style := [fsBold];
     font.Color := $000000;
     textout(35,32,inttostr(hooverEL));
     font.Height := 18;
     font.Style := [];
     el := element[hooverEL].parent;
     if el > 0 then textout(5,35,inttostr(el));
     el := element[hooverEL].child;
     if el > 0 then textout(95,35,inttostr(el));
     el := element[hooverEL].next;
     if el > 0 then textout(55,65,inttostr(el));
     el := element[hooverEL].previous;
     if el > 0 then textout(55,5,inttostr(el));
    end;
  end;
 form1.ellinkbox.Canvas.Draw(0,0,ellinkmap);
end;

procedure setActiveElement(el : word);
var oldEl : word;
begin
 oldEl := actEL;
 actEL := el;
 repaintElement(oldEl);
 repaintElement(actEL);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.Canvas.Draw(0,0,map);
end;

procedure destroyNotification(del : word);
//message from tree unit
begin
 element[del].status := esFree;
 inc(freeElements);
 form1.freeElementslabel.Caption := inttostr(freeElements);
end;

procedure newmap;
//paint map and transfer to paintbox
begin
 paintmap;
 form1.PaintBox1.Canvas.draw(0,0,map);
end;

procedure SaveProc;
//save tree including undo information
var n,el : word;
begin
 SVtree[1] := (getEdbase shl 8) or getEDstep;
 n := 2;
 for el := 1 to maxElement do
  if element[el].status = esActive then
   begin
    SVtree[n] := (byte(svEL) shl 8) or element[el].mark;
    SVtree[n+1] := el;
    SVtree[n+2] := element[el].child;
    SVtree[n+3] := element[el].next;
    SVtree[n+4] := (element[el].Cstep shl 8) or element[el].Dstep;
    inc(n,5);
   end;
 SVtree[n] := byte(svEnd) shl 8;
end;

procedure OpenProc;
var code,n,el,w : word;
    stopflag : boolean;
begin
 stopflag := false;
 setEdbase(SVtree[1] shr 8);
 setEdStep(SVtree[1] and $ff);
 n := 2;
 repeat
  w := SVtree[n];
  code := w shr 8;
  case Tsavecode(code) of
   svEL : begin
           el := SVtree[n+1];
           with element[el] do
            begin
             mark := w and $ff;
             child := SVtree[n+2];
             next := SVtree[n+3];
             w := SVtree[n+4];
             Cstep := (w shr 8);
             Dstep := (w and $ff);
            end;
           inc(n,5);
          end;
   svEnd: stopflag := true;
  end;//case
 until stopflag;
end;

procedure compressProc;
var el,n : word;
    link : Tlink;
begin
 n := 1;
 el := 1;
 link := ltNext;
 repeat
  case link of
   ltNext : begin
             CPtree[n] := byte(svEL);
             CPtree[n+1] := element[el].mark;
             inc(n,2);
            end;
   ltChild : begin
              CPtree[n] := byte(svPar1);
              inc(n);
              CPtree[n] := byte(svEL);
              CPtree[n+1] := element[el].mark;
              inc(n,2);
             end;
   ltPrevious : ;
   ltParent : begin
               CPtree[n] := byte(svPar2);
               inc(n);
              end;
  end;
  link := scanElement(el,link);
 until (el = 1) and ((link=ltNone) or (link=ltPrevious));
 CPtree[n] := byte(svEnd);
 compressflag := true;
end;

procedure expandProc;
var stopflag,childflag : boolean;
    n,oldEL,newEL,par : word;
    code : TSavecode;
begin
 n := 1;      //index for CPtree byte array
 oldEL := 0;
 newEL := 0;  //next free element
 par := 0;
 childflag := false;  //'(' detected
 stopflag := false;
 repeat
  code := TSavecode(CPtree[n]);
  case code of
   svEL   : begin
             inc(newEL);
             if childflag then
              begin
               element[oldEL].child := newEL;
               element[newEL].parent := oldEL;
               par := oldEL;
               childflag := false;
              end
              else begin
                    if oldEL > 0 then element[oldEL].next := newEL;
                    element[newEL].previous := oldEL;
                    element[newEL].parent := par;
                   end;
             element[newEL].mark := CPtree[n+1];
             element[newEL].status := esActive;
             inc(n,2);
             oldEL := newEL;
            end;
   svPar1 : begin
             childflag := true;
             inc(n);
            end;
   svPar2 : begin
             oldEL := par;
             par := element[oldEL].parent;
             inc(n);
            end; 
   svEnd  : stopflag := true;
  end;
 until stopflag;
end;

procedure TForm1.afterBtnClick(Sender: TObject);
//common procedure for adding elements
var el : word;
    tg : longInt;
    OK : boolean;
begin
 OK := false;
 tg := TSpeedbutton(sender).Tag;
 with element[actEL] do
  begin
   case tg of
    1 : OK := (topY < 24);
    2 : OK := (topY < 24) and ((previous > 0) or (parent > 0));
    3,
    4 : OK := ((child = 0) and (posX < 10)) or
              ((child > 0) and (topY < 24));
   end;//case
   if OK then
    begin
     el := getFreeElement;
     if el > 0 then
      begin
       case tg of
        1 : placeA(actEL,el);                   //place after
        2 : if actEL > 1 then placeB(actEL,el); //..    before
        3 : placeChildB(actEL,el);              //..    as 1st child
        4 : placeChildA(actEL,el);              //..    as last child
       end;//case
       actEL := el;
       element[el].status := esActive;
       newmap;
      end;
     showEdCounts;
    end;//if OK
   end;//with element
end;

procedure TForm1.replaceBtnClick(Sender: TObject);
var el : word;
begin
 if actEL <= 1 then exit;
//
 el := getFreeElement;
 if el > 0 then
  begin
   replaceEL(actEL,el);
   element[el].status :=esActive;
   newactEL;
   showEdcounts;
   newmap;
  end;
end;

procedure TForm1.deleteBtnClick(Sender: TObject);
//delete selected element
var el : word;
begin
 if actEL <= 1 then exit;
//
 el := ActEL;
 newActEL;
 deleteEL(el);
 showEdCounts;
 newmap;
end;

procedure TForm1.markBtnClick(Sender: TObject);
// mark/unmark selected element
var b : byte;
begin
 b := TSpeedbutton(sender).tag;
 with element[actEL] do
  if (mark = 0) then mark := b else mark := 0;
 repaintElement(actEl);
end;

procedure TForm1.destroyBtnClick(Sender: TObject);
//destroy selected element
begin
 if actEL > 1 then
  begin
   destroyEL(actEL);
   actEL := 1;
   newmap;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
//navigation
var repnt : boolean;
    newEl : word;
begin
 case key of
  VK_LEFT : repnt := getParent(newEL,actEL);  //left;
  VK_UP : repnt := getPrevious(newEL,actEL);  //up;
  VK_RIGHT : repnt := getChild(newEL,actEL) ; //right;
  VK_DOWN : repnt := getNext(newEL,actEL);    //down;
  else repnt := false;
 end;//case
 if repnt then setActiveElement(newEl);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var el : word;
begin
 if XYtoElement(el,x,y) then
  if testELdeleted(el) then setActiveElement(0)
   else setActiveElement(el);
end;

procedure TForm1.FormPaint(Sender: TObject);
//paint edges around paintbox1
begin
 paintedges(paintbox1,0,0);
 paintedges(ellinkbox,0,0);
end;

//create - destroy

procedure TForm1.FormCreate(Sender: TObject);
begin
 freeElements := maxElement;
 inittree;
 map := TBitmap.Create;
 with map do
  begin
   width := paintbox1.Width;
   height := paintbox1.height;
  end;
 ellinkmap := Tbitmap.create;
 with ellinkmap do
  begin
   pixelformat := pf32bit;
   width := ellinkbox.Width;
   height := ellinkbox.height;
  end;
 initElements;
 paintmap;
 paintlinks;
 activecontrol := nil;
 checkbox1.Checked := false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 map.free;
 ellinkmap.free;
end;

procedure TForm1.CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if checkbox1.Checked then startTreeLinking
  else stopTreeLinking;
 activecontrol:= nil; 
end;

procedure TForm1.scanBtnClick(Sender: TObject);
begin
 nextBtn.enabled := scanBtn.down;
 slink := ltNext;
 scanStart := actEL;
end;

procedure TForm1.nextBtnClick(Sender: TObject);
//show next selected element in scan
var el : word;
begin
 el := actEL;
 if scanBtn.Down then
  begin
   slink := scanElement(el,slink);
   setActiveElement(el);
   if (actEL = scanStart) and ((slink=ltNone) or (slink=ltPrevious)) then
    scanBtn.Down := false;
  end;
end;

procedure TForm1.initBtnClick(Sender: TObject);
begin
 saveflag := false;
 compressflag := false;
 initElements;
 InitTree;
 checkbox1.Checked :=false;
 showEdCounts;
 newmap;
 hooverEL := 0;
 paintlinks;
end;

procedure TForm1.undoBtnClick(Sender: TObject);
begin
 UndoLastStep;
 newActEL;
 newmap;
 showEdCounts;
end;

procedure TForm1.cleanupBtnClick(Sender: TObject);
begin
 removeUndoCounts;//--> xtree2
 newmap;
 showEdcounts;
end;

procedure TForm1.compressBtnClick(Sender: TObject);
//compress tree, undo information is lost
begin
 compressProc;
 compressflag := true;
end;

procedure TForm1.expandBtnClick(Sender: TObject);
//expand tree
begin
 if compressflag then
  begin
   inittree;
   expandProc;
   actEL := 1;
   newmap;
  end
  else showmessage('no compressed tree');
end;

procedure TForm1.saveBtnClick(Sender: TObject);
//save undo information
begin
 saveProc;
 saveflag:= true;
end;

procedure TForm1.reloadBtnClick(Sender: TObject);
//reload also undo information
begin
 if saveFlag then begin
                   initTree;
                   openproc;
                   addBacklinks;
                   actEL := 1;
                   newmap;
                  end
  else showmessage('tree not saved');
end;

procedure undomessage(um : TUndoMessage; nel,del : word);
begin
 case um of
  umDestroy : begin
               element[del].status := esFree;
               element[del].mark := 0;
               inc(freeElements);
               form1.freeElementslabel.Caption := inttostr(freeElements);
              end;
  umUndoDelete : begin
                  setActiveElement(nel);
                 end;
  umUndoReplace : begin
                   setActiveElement(nel);
                   inc(freeElements);
                   element[del].status := esFree;
                  end;
 end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var el : word;
begin
 if XYtoElement(el,x,y) then
  if (el <> hooverEL) then
   begin
    hooverEL := el;
    paintLinks;
   end;
end;

procedure TForm1.ellinkboxPaint(Sender: TObject);
begin
 ellinkbox.Canvas.Draw(0,0,ellinkmap);
end;

end.
